"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RuntimeError = void 0;
var inspectObject_1 = require("./inspectObject");
var RuntimeError = /** @class */ (function (_super) {
    __extends(RuntimeError, _super);
    function RuntimeError(message, details) {
        var _config = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            _config[_i - 2] = arguments[_i];
        }
        var _this = _super.call(this, message) || this;
        _this.name = 'RuntimeError';
        _this.detailsString = '';
        _this.details = details;
        _this.detailsString = message;
        var _a = prepareArgs(_config), _b = _a.skipStackLines, skipStackLines = _b === void 0 ? 0 : _b, _c = _a.depth, depth = _c === void 0 ? 10 : _c, _d = _a.limitStackTrace, limitStackTrace = _d === void 0 ? 100 : _d;
        if (details) {
            var detailsString = (0, inspectObject_1.inspectObject)(details, { tabSize: 0, depth: depth })
                //
                .slice(0, limitStackTrace);
            _this.detailsString += "\n".concat(detailsString);
            var stack = (_this.stack || '').split('\n');
            var newStack = __spreadArray(__spreadArray(__spreadArray([
                message
            ], __read(stack.slice(0, 1).filter(function (e) { return e === '\n'; })), false), [
                "Details: ".concat(detailsString)
            ], false), __read(stack.slice(1 + skipStackLines)), false);
            _this.stack = newStack.join('\n');
        }
        return _this;
    }
    return RuntimeError;
}(Error));
exports.RuntimeError = RuntimeError;
function prepareArgs(_config) {
    return typeof _config[0] === 'object'
        ? _config[0]
        : {
            skipStackLines: _config[0],
            depth: _config[1],
        };
}
