"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StrictMap = void 0;
var RuntimeError_1 = require("./RuntimeError");
var StrictMap = /** @class */ (function () {
    function StrictMap() {
        var _this = this;
        this.set = function (key, value) {
            return _this.nativeMap.set(key, value);
        };
        this.has = function (key) {
            return _this.nativeMap.has(key);
        };
        this.keys = function () {
            return _this.nativeMap.keys();
        };
        this.entries = function () {
            return _this.nativeMap.entries();
        };
        this.clear = function () {
            return _this.nativeMap.clear();
        };
        this.delete = function (key) {
            return _this.nativeMap.delete(key);
        };
        this.values = function () {
            return _this.nativeMap.values();
        };
        this.nativeMap = new Map();
    }
    StrictMap.prototype.ensure = function (key) {
        this.get(key);
    };
    StrictMap.prototype.get = function (key, options) {
        if (options === void 0) { options = {}; }
        if (!this.nativeMap.has(key)) {
            var onNull = options.onNull;
            if (onNull) {
                var newItem = onNull(key, this);
                if (newItem) {
                    this.set(key, newItem);
                    return newItem;
                }
            }
            throw new StrictMapError("There is no item with key \"".concat(key, "\""), {
                validKeys: __spreadArray([], __read(this.nativeMap.keys()), false),
            });
        }
        var value = this.nativeMap.get(key);
        if (value === undefined || value === null) {
            throw new StrictMapError("Expected value to be not nullable, but received ".concat(value === null ? 'null' : 'undefined', "."), {
                validKeys: __spreadArray([], __read(this.nativeMap.keys()), false),
            });
        }
        return value;
    };
    Object.defineProperty(StrictMap.prototype, "size", {
        get: function () {
            return this.nativeMap.size;
        },
        enumerable: false,
        configurable: true
    });
    return StrictMap;
}());
exports.StrictMap = StrictMap;
var StrictMapError = /** @class */ (function (_super) {
    __extends(StrictMapError, _super);
    function StrictMapError(message, details) {
        var _this = _super.call(this, message, details) || this;
        _this.name = 'StrictMapError';
        return _this;
    }
    return StrictMapError;
}(RuntimeError_1.RuntimeError));
