"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var formatGraphQL_1 = require("../formatGraphQL");
describe('formatCode', function () {
    test('query', function () { return __awaiter(void 0, void 0, void 0, function () {
        var sut;
        return __generator(this, function (_a) {
            sut = (0, formatGraphQL_1.formatGraphQL)('query users ($name: Int   ){name}').split('\n');
            expect(sut).toEqual([
                'query users($name: Int) {',
                '  name',
                '}',
            ]);
            return [2 /*return*/];
        });
    }); });
    test('mutation', function () { return __awaiter(void 0, void 0, void 0, function () {
        var sut;
        return __generator(this, function (_a) {
            sut = (0, formatGraphQL_1.formatGraphQL)('mutation users ($name: Int   ){name}').split('\n');
            expect(sut).toEqual([
                'mutation users($name: Int) {',
                '  name',
                '}',
            ]);
            return [2 /*return*/];
        });
    }); });
    test('fragment', function () { return __awaiter(void 0, void 0, void 0, function () {
        var sut;
        return __generator(this, function (_a) {
            sut = (0, formatGraphQL_1.formatGraphQL)('fragment users on User {name}').split('\n');
            expect(sut).toEqual([
                'fragment users on User {',
                '  name',
                '}',
            ]);
            return [2 /*return*/];
        });
    }); });
    test('fullQuery', function () { return __awaiter(void 0, void 0, void 0, function () {
        var fullQuery, sut;
        return __generator(this, function (_a) {
            fullQuery = [
                'fragment Breadcrumb2402738501Fragment on Breadcrumb {',
                '      id',
                '      active',
                '      name',
                '      parentId',
                '    }',
                '    ',
                '    fragment Product2040566541Fragment on Product {',
                '      sku',
                '      breadcrumb {',
                '        ...Breadcrumb2402738501Fragment',
                '      }',
                '      parents(id: $productById_parents_id) {',
                '        ...Product3389259298Fragment',
                '      }',
                '      innerParent(limit: $productById_parents_innerParent_limit) {',
                '        ...Product2040566541Fragment',
                '      }',
                '    }',
                '    ',
                '    fragment Product3389259298Fragment on Product {',
                '      sku',
                '      breadcrumb {...Breadcrumb2402738501Fragment}',
                '      parents(id: $productById_parents_id) {...Product3389259298Fragment}',
                '      innerParent(limit: $productById_parents_innerParent_limit) {...Product2040566541Fragment}',
                '    }',
                '    ',
                '    query productById($productById_id: ID!, $productById_sku: String!, $productById_parents_id: ID = 155, $productById_parents_innerParent_limit: Int = 2) {',
                '      productById(',
                '        id: $productById_id',
                '        sku: $productById_sku',
                '        id: $productById_parents_id',
                '        limit: $productById_parents_innerParent_limit',
                '      ) {',
                '        sku',
                '        breadcrumb {',
                '          ...Breadcrumb2402738501Fragment',
                '        }',
                '        parents(id: $productById_parents_id) {',
                '          ...Product3389259298Fragment',
                '        }',
                '        innerParent(limit: $productById_parents_innerParent_limit) {',
                '          ...Product2040566541Fragment',
                '        }',
                '      }',
                '    }',
            ].join(' ');
            sut = (0, formatGraphQL_1.formatGraphQL)(fullQuery).split('\n');
            expect(sut).toEqual([
                'fragment Breadcrumb2402738501Fragment on Breadcrumb {',
                '  id',
                '  active',
                '  name',
                '  parentId',
                '}',
                '',
                'fragment Product2040566541Fragment on Product {',
                '  sku',
                '  breadcrumb {',
                '    ...Breadcrumb2402738501Fragment',
                '  }',
                '  parents(id: $productById_parents_id) {',
                '    ...Product3389259298Fragment',
                '  }',
                '  innerParent(limit: $productById_parents_innerParent_limit) {',
                '    ...Product2040566541Fragment',
                '  }',
                '}',
                '',
                'fragment Product3389259298Fragment on Product {',
                '  sku',
                '  breadcrumb {',
                '    ...Breadcrumb2402738501Fragment',
                '  }',
                '  parents(id: $productById_parents_id) {',
                '    ...Product3389259298Fragment',
                '  }',
                '  innerParent(limit: $productById_parents_innerParent_limit) {',
                '    ...Product2040566541Fragment',
                '  }',
                '}',
                '',
                'query productById($productById_id: ID!, $productById_sku: String!, $productById_parents_id: ID = 155, $productById_parents_innerParent_limit: Int = 2) {',
                '  productById(',
                '    id: $productById_id',
                '    sku: $productById_sku',
                '    id: $productById_parents_id',
                '    limit: $productById_parents_innerParent_limit',
                '  ) {',
                '    sku',
                '    breadcrumb {',
                '      ...Breadcrumb2402738501Fragment',
                '    }',
                '    parents(id: $productById_parents_id) {',
                '      ...Product3389259298Fragment',
                '    }',
                '    innerParent(limit: $productById_parents_innerParent_limit) {',
                '      ...Product2040566541Fragment',
                '    }',
                '  }',
                '}',
            ]);
            return [2 /*return*/];
        });
    }); });
});
