"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var BJSON_1 = require("../BJSON");
var emailRegex_1 = require("../emailRegex");
var getTypeName_1 = require("../getTypeName");
var simpleObjectClone_1 = require("../simpleObjectClone");
describe('simpleObjectClone', function () {
    var getObject = function () { return ({
        date: new Date(0),
        regex: emailRegex_1.EmailRegex,
        name: 'antonio',
        age: NaN,
        otherDate: new Date(2),
        deep: {
            a: {
                b: {
                    c: /1234/gim,
                },
            },
        },
    }); };
    it('clone', function () {
        var obj = getObject();
        var sut = (0, simpleObjectClone_1.simpleObjectClone)(obj);
        expect(sut).toEqual(getObject());
    });
    it('stringify', function () { return __awaiter(void 0, void 0, void 0, function () {
        var obj, str;
        return __generator(this, function (_a) {
            obj = getObject();
            str = BJSON_1.BJSON.stringify(obj);
            expect(typeof str).toEqual('string');
            return [2 /*return*/];
        });
    }); });
    it('parse', function () { return __awaiter(void 0, void 0, void 0, function () {
        var str, value;
        return __generator(this, function (_a) {
            str = BJSON_1.BJSON.stringify(getObject());
            value = BJSON_1.BJSON.parse(str);
            expect(value).toEqual(getObject());
            return [2 /*return*/];
        });
    }); });
    it('stringify date', function () { return __awaiter(void 0, void 0, void 0, function () {
        var date, str;
        return __generator(this, function (_a) {
            date = new Date('1989-01-01');
            str = BJSON_1.BJSON.stringify(date);
            expect(str).toEqual('"ːDateː(1989-01-01T00:00:00.000Z)"');
            expect(BJSON_1.BJSON.parse(str)).toEqual(date);
            return [2 /*return*/];
        });
    }); });
    it('stringify NaN', function () { return __awaiter(void 0, void 0, void 0, function () {
        var value, str;
        return __generator(this, function (_a) {
            value = NaN;
            str = BJSON_1.BJSON.stringify(value);
            expect(BJSON_1.BJSON.parse(str)).toEqual(value);
            return [2 /*return*/];
        });
    }); });
    it('stringify [NaN]', function () { return __awaiter(void 0, void 0, void 0, function () {
        var value, str;
        return __generator(this, function (_a) {
            value = [NaN];
            str = BJSON_1.BJSON.stringify(value);
            expect(BJSON_1.BJSON.parse(str)).toEqual(value);
            return [2 /*return*/];
        });
    }); });
    test('custom replacer', function () {
        var value = [
            new Date(),
            /abc/,
            { a: 1, b: { c: new Date() } },
            null,
            undefined,
        ];
        var str = BJSON_1.BJSON.stringify({ 12: value, b: false }, {
            quoteValues: function (str, _a) {
                var key = _a.key;
                return key === 'b' ? "".concat(str, "____") : "".concat(str);
            },
            handler: function (_a) {
                var _b;
                var serializer = _a.serializer, value = _a.value, key = _a.key;
                if (key === 'b')
                    return 'HMM';
                var typeName = (0, getTypeName_1.getTypeName)(value);
                if (['Object', 'Array'].includes(typeName))
                    return;
                if (['String', 'Number'].includes(typeName))
                    return value === null || value === void 0 ? void 0 : value.toString();
                return ((_b = serializer === null || serializer === void 0 ? void 0 : serializer.formatter) === null || _b === void 0 ? void 0 : _b.tsName()) || typeName;
            },
        });
        expect(str).toEqual('{"12":[Date,RegExp,{"a":1,"b":HMM____},Null,undefined],"b":HMM____}');
    });
});
