"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertEqual = exports.areEqual = void 0;
var fast_equals_1 = require("fast-equals");
var typeUtils_1 = require("./typeUtils");
function areEqual(a, b) {
    return (0, fast_equals_1.deepEqual)(a, b);
}
exports.areEqual = areEqual;
function assertEqual(value, toBe, message, details) {
    if (message === void 0) { message = 'UNEXPECTED_VALUE'; }
    if (details === void 0) { details = {}; }
    if (!areEqual(value, toBe)) {
        throw new typeUtils_1.TypeAssertionError(message, details);
    }
}
exports.assertEqual = assertEqual;
