"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertSame = void 0;
var RuntimeError_1 = require("./RuntimeError");
var areEqual_1 = require("./areEqual");
var dynamicRequire_1 = require("./dynamicRequire");
var jestDiff = (0, dynamicRequire_1.dynamicRequire)('jest-diff', module);
function assertSame(message, a, b) {
    if (!(0, areEqual_1.areEqual)(a, b)) {
        if (jestDiff) {
            console.info(jestDiff.diff(a, b));
        }
        throw new RuntimeError_1.RuntimeError(message, {
            expected: a,
            actual: b,
        });
    }
}
exports.assertSame = assertSame;
