"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.areEqual = areEqual;
exports.assertEqual = assertEqual;

var _fastEquals = require("fast-equals");

var _typeUtils = require("./typeUtils");

function areEqual(a, b) {
  return (0, _fastEquals.deepEqual)(a, b);
}

function assertEqual(value, toBe) {
  var message = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'UNEXPECTED_VALUE';
  var details = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if (!areEqual(value, toBe)) {
    throw new _typeUtils.TypeAssertionError(message, details);
  }
}
//# sourceMappingURL=areEqual.js.map