"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assertSame = assertSame;

var _RuntimeError = require("./RuntimeError");

var _areEqual = require("./areEqual");

var _dynamicRequire = require("./dynamicRequire");

var jestDiff = (0, _dynamicRequire.dynamicRequire)('jest-diff', module);

function assertSame(message, a, b) {
  if (!(0, _areEqual.areEqual)(a, b)) {
    if (jestDiff) {
      console.info(jestDiff.diff(a, b));
    }

    throw new _RuntimeError.RuntimeError(message, {
      expected: a,
      actual: b
    });
  }
}
//# sourceMappingURL=assertSame.js.map