"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Contextify = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

var _vm = _interopRequireDefault(require("vm"));

var _useProcess = require("../useProcess");

var _builtinModules = require("./builtin-modules");

var _Process$env;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ORIGINAL_REQUIRE = require;
var GET_PATHS = ORIGINAL_REQUIRE.resolve.paths;
var IS_PROD_ENV = ((_Process$env = _useProcess.Process.env) === null || _Process$env === void 0 ? void 0 : _Process$env.NODE_ENV) === 'production';

var Contextify = /*#__PURE__*/function () {
  function Contextify(options) {
    var _this = this;

    _classCallCheck(this, Contextify);

    _defineProperty(this, "allBranches", new Set());

    _defineProperty(this, "persistentCache", void 0);

    _defineProperty(this, "filePathCache", Object.create(null));

    _defineProperty(this, "buildByExtension", void 0);

    _defineProperty(this, "allowSourcemaps", void 0);

    _defineProperty(this, "mock", void 0);

    _defineProperty(this, "contextModuleName", 'use-task-payload');

    _defineProperty(this, "getFileContents", function (filename) {
      return _this._readFileFromDisk(filename);
    });

    _defineProperty(this, "resolveModule", function (path, currentDirname) {
      return _this._findNodeModulePath(path, currentDirname);
    });

    _defineProperty(this, "prepareRequire", function (config) {
      var persistentCache = _this.persistentCache,
          mock = _this.mock;
      var currentDirname = config.currentDirname,
          _config$transitiveCac = config.transitiveCache,
          transitiveCache = _config$transitiveCac === void 0 ? Object.create(null) : _config$transitiveCac,
          payload = config.payload;
      var self = _this;

      var vmContext = function () {
        var vmContext = config.vmContext,
            sandbox = config.sandbox;
        if (vmContext) return vmContext;
        if (!sandbox) return null;
        if (sandbox === true) return Contextify.prepareContext({});
        if (_vm.default.isContext(sandbox)) return sandbox;
        return Contextify.prepareContext(sandbox);
      }();

      return function require(moduleName) {
        var filename = self.resolveModule(moduleName, currentDirname);
        var mocked = mock === null || mock === void 0 ? void 0 : mock({
          moduleName: moduleName,
          filename: filename,
          payload: payload
        });

        if (mocked !== undefined) {
          transitiveCache[filename] = mocked;
          return mocked;
        }

        if (transitiveCache[filename]) {
          return transitiveCache[filename].exports;
        }

        if (moduleName === self.contextModuleName) {
          var _module = {
            exports: function exports() {
              return payload;
            }
          };
          transitiveCache[filename] = _module;
          return _module.exports;
        }

        if ((0, _builtinModules.isBuiltInModule)(moduleName)) {
          return ORIGINAL_REQUIRE(moduleName);
        }

        if (!filename) {
          throw new Error("Cannot find module ".concat(moduleName));
        }

        var closure = persistentCache[filename];

        if (!closure) {
          var code = self._readFileWrapped(filename);

          var script = new _vm.default.Script(code, {
            filename: filename,
            displayErrors: false
          });
          closure = vmContext ? script.runInContext(vmContext, {
            filename: filename,
            displayErrors: true
          }) : script.runInThisContext({
            filename: filename,
            displayErrors: true
          });

          if (!vmContext) {
            persistentCache[filename] = closure;
          }
        }

        var dirname = _path.default.dirname(filename);

        var module = {
          filename: filename,
          exports: {},
          require: self.prepareRequire({
            currentDirname: dirname,
            transitiveCache: transitiveCache,
            payload: payload,
            vmContext: vmContext
          })
        };
        transitiveCache[filename] = module;
        var $TASK_MODULE_UTILS = {
          sourceMaps: function sourceMaps() {
            if (!self.allowSourcemaps) return;
            if (transitiveCache.installedSourcemaps) return;
            transitiveCache.installedSourcemaps = true;

            function retrieveFile(filename) {
              return self.persistentCache["".concat(filename, ".wrapped_module_contents")] || null;
            }

            require('source-map-support').install({
              retrieveFile: retrieveFile,
              isTask: true
            });
          }
        };
        closure(module.exports, module.require, module, filename, dirname, $TASK_MODULE_UTILS);
        return module.exports;
      };
    });

    _defineProperty(this, "_readFileWrapped", function (filename) {
      var _this$buildByExtensio;

      var KEY = "".concat(filename, ".wrapped_module_contents");
      if (_this.persistentCache[KEY]) return _this.persistentCache[KEY];

      var extension = _path.default.extname(filename);

      var code;

      if ((_this$buildByExtensio = _this.buildByExtension) !== null && _this$buildByExtensio !== void 0 && _this$buildByExtensio[extension]) {
        code = _this.buildByExtension[extension](filename);
      } else {
        code = _this.getFileContents(filename);
      }

      return _this.persistentCache[KEY] = wrapModuleCode(code);
    });

    _defineProperty(this, "_findNodeModulePath", function (path, currentDirname) {
      if (path === _this.contextModuleName) return _this.contextModuleName;
      var cacheKey = "".concat(currentDirname, "_").concat(path);
      if (_this.filePathCache[cacheKey]) return _this.filePathCache[cacheKey];
      var filePath = ORIGINAL_REQUIRE.resolve(path, {
        paths: [currentDirname].concat(_toConsumableArray(GET_PATHS(currentDirname) || []))
      });
      return _this.filePathCache[cacheKey] = filePath;
    });

    _defineProperty(this, "diskFilesCache", Object.create(null));

    _defineProperty(this, "_readFileFromDisk", function (filename) {
      var KEY = "".concat(filename, ".plain_disk_content");
      if (_this.diskFilesCache[KEY]) return _this.diskFilesCache[KEY];
      return _this.diskFilesCache[KEY] = _fs.default.readFileSync(filename, 'utf8');
    });

    this.persistentCache = options.persistentCache || Object.create(null);
    this.buildByExtension = options.buildByExtension;
    this.allowSourcemaps = typeof options.allowSourcemaps !== 'undefined' ? options.allowSourcemaps : !IS_PROD_ENV;
    this.mock = options.mock || null;

    if (options.contextModuleName) {
      this.contextModuleName = options.contextModuleName;
    }

    if (options.getFileContents) {
      this.getFileContents = options.getFileContents;
    }

    if (options.resolveModule) {
      var resolveModule = options.resolveModule;
      var self = this;

      this.resolveModule = function (path, currentDirname) {
        if ((0, _builtinModules.isBuiltInModule)(path)) return path;
        if (path === self.contextModuleName) return self.contextModuleName;
        var result = resolveModule(path, currentDirname);

        if (!result) {
          throw new Error("Cannot find module ".concat(path, " - currentDirname: ").concat(currentDirname));
        }

        return result;
      };
    }
  }

  _createClass(Contextify, null, [{
    key: "prepareContext",
    value: function prepareContext(sandbox) {
      return _vm.default.createContext(_objectSpread({
        global: {
          isContextifySandbox: true
        },
        isTaskVMSandbox: true,
        process: process,
        console: console,
        version: parseInt(process.versions.node.split('.')[0]),
        setTimeout: setTimeout,
        setInterval: setInterval,
        setImmediate: setImmediate,
        clearTimeout: clearTimeout,
        clearInterval: clearInterval,
        clearImmediate: clearImmediate,
        String: String,
        Number: Number,
        Buffer: Buffer,
        Boolean: Boolean,
        Array: Array,
        Date: Date,
        Error: Error,
        EvalError: EvalError,
        RangeError: RangeError,
        ReferenceError: ReferenceError,
        SyntaxError: SyntaxError,
        TypeError: TypeError,
        URIError: URIError,
        RegExp: RegExp,
        Function: Function,
        Object: Object,
        Proxy: Proxy,
        Reflect: Reflect,
        Map: Map,
        WeakMap: WeakMap,
        Set: Set,
        WeakSet: WeakSet,
        Promise: Promise,
        Symbol: Symbol
      }, sandbox));
    }
  }]);

  return Contextify;
}();

exports.Contextify = Contextify;

function wrapModuleCode(code) {
  var strict = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var MODULE_PREFIX = '(function (exports, require, module, __filename, __dirname, $TASK_MODULE_UTILS) { ';
  var STRICT_MODULE_PREFIX = MODULE_PREFIX + '"use strict";$TASK_MODULE_UTILS.sourceMaps();\n';
  var MODULE_SUFFIX = '\n});';
  var prefix = strict ? STRICT_MODULE_PREFIX : MODULE_PREFIX;
  return prefix + code + MODULE_SUFFIX;
}
//# sourceMappingURL=Contextify.js.map