"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getConstructorName = getConstructorName;
exports.getTypeName = getTypeName;

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function getTypeName(input) {
  if (typeof input === 'number' && isNaN(input)) return 'NaN';
  if (input === null) return 'Null';
  if (input === undefined) return 'Undefined';
  if (input === Infinity) return 'Infinity';
  return getConstructorName(input);
}

function getConstructorName(input) {
  var _input$constructor, _input$constructor$to, _input$constructor$to2;

  var constructorName = input === null || input === void 0 ? void 0 : (_input$constructor = input.constructor) === null || _input$constructor === void 0 ? void 0 : (_input$constructor$to = _input$constructor.toString) === null || _input$constructor$to === void 0 ? void 0 : (_input$constructor$to2 = _input$constructor$to.call(_input$constructor).match(/function ([^(]*)/)) === null || _input$constructor$to2 === void 0 ? void 0 : _input$constructor$to2[1];
  if (constructorName) return constructorName;

  if (input !== null && _typeof(input) === 'object') {
    // objects without constructor (with Object.create(null))
    return 'Object';
  }

  return 'Unknown';
}
//# sourceMappingURL=getTypeName.js.map