"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.inspectObject = inspectObject;

var _dynamicRequire2 = require("./dynamicRequire");

var _getTypeName = require("./getTypeName");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function inspectObject(inputObject) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var appendDetailIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var _options$depth = options.depth,
      depth = _options$depth === void 0 ? 2 : _options$depth,
      _options$tabSize = options.tabSize,
      tabSize = _options$tabSize === void 0 ? 6 : _options$tabSize,
      named = options.named,
      _options$transformLin = options.transformLine,
      transformLine = _options$transformLin === void 0 ? appendDetailIndex ? function (text, index) {
    return "[".concat(index, "]: ").concat(text);
  } : function (t) {
    return t;
  } : _options$transformLin;

  var inspect = function inspect(obj, index) {
    var text = typeof obj === 'string' ? obj : _inspectObject(obj, {
      depth: depth
    });

    if (named === true) {
      text = "".concat((0, _getTypeName.getTypeName)(obj), " ").concat(text);
    } else if (named) {
      text = "".concat(named, " ").concat(text);
    }

    return transformLine(text, index, obj);
  };

  var text = inspect(inputObject, 0);
  return appendTab(text, tabSize);
}

function appendTab(text) {
  var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 4;
  var tab = spaces(size);
  return text.split('\n').map(function (t) {
    return "".concat(tab).concat(t);
  }).join('\n');
}

function spaces(size) {
  var space = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ' ';
  return _toConsumableArray(Array(size)).map(function () {
    return space;
  }).join('');
}

function _inspectObject(obj, config) {
  var _dynamicRequire;

  var nodeIns = (_dynamicRequire = (0, _dynamicRequire2.dynamicRequire)('util')) === null || _dynamicRequire === void 0 ? void 0 : _dynamicRequire.inspect;

  if (nodeIns) {
    return nodeIns(obj, config);
  }

  try {
    return JSON.stringify(obj, null, 2);
  } catch (e) {
    return 'FILED TO INSPECT';
  }
}
//# sourceMappingURL=inspectObject.js.map