"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LogLevels = void 0;
exports.getLogLevelInfo = getLogLevelInfo;

var _env = require("./env");

var _typeUtils = require("./typeUtils");

var _useProcess = require("./useProcess");

var LogLevels = (0, _typeUtils.tuple)('error', 'info', 'crit', 'warning', 'debug');
exports.LogLevels = LogLevels;
var LEVEL = _useProcess.Process.env.LOG_LEVEL || '';

if (!LEVEL && !(0, _env.isProduction)()) {
  _useProcess.Process.env.LOG_LEVEL = '2';
}

function getLogLevelInfo() {
  var env = _useProcess.Process.env.LOG_LEVEL;
  var logInfo = env === '2';
  var logWarn = env === '1';

  if (env === '0') {
    return new Set();
  }

  var levels = ['error', 'crit'];

  if (logInfo) {
    levels.push('info', 'warning');
  }

  if (logWarn) {
    levels.push('warning');
  }

  if (!(0, _env.isProduction)()) {
    levels.push('debug');
  }

  return new Set(levels);
}
//# sourceMappingURL=logLevels.js.map