"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.maybeRequired = maybeRequired;

function maybeRequired(expected, isRequired) {
  var keys = Object.keys(expected);
  var itemName = keys[0];
  var value = expected[itemName];

  if (isRequired && (value === null || value === undefined)) {
    var error = new Error("Expected ".concat(itemName, " to be defined; found ").concat(value, "."));
    var stack = (error.stack || '').split('\n');
    error.stack = stack.slice(0, 1).concat(stack.slice(1)).join('\n');
    throw error;
  }

  return value;
}
//# sourceMappingURL=maybeRequired.js.map