function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { dateSerialize } from './dateSerialize';
import { getTypeName } from './getTypeName';
export var SEP = 'ː';

function withSEP(txt) {
  return "".concat(SEP).concat(txt).concat(SEP);
}

export var BJSON_UNDEFINED = withSEP('undef');
export var BJSON_FUNCTION = withSEP('func');
export var Serializer = /*#__PURE__*/function () {
  function Serializer(formatter) {
    _classCallCheck(this, Serializer);

    _defineProperty(this, "name", void 0);

    _defineProperty(this, "sep", void 0);

    _defineProperty(this, "blockStart", void 0);

    _defineProperty(this, "blockEnd", void 0);

    _defineProperty(this, "paramSep", void 0);

    _defineProperty(this, "formatter", void 0);

    this.formatter = formatter;
    this.name = formatter.name;
    this.sep = Serializer.SEP;
    this.paramSep = this.sep;
    this.blockStart = "".concat(this.sep).concat(this.name).concat(this.sep, "(");
    this.blockEnd = ")";
  }

  _createClass(Serializer, [{
    key: "stringify",
    value: function stringify(value) {
      var _this = this;

      var tested = this.formatter.match(value);
      if (tested === undefined) return;

      var wrap = function wrap(txt) {
        return "".concat(_this.blockStart).concat(txt).concat(_this.blockEnd);
      };

      if (this.formatter.jsonReplacer) {
        return this.formatter.jsonReplacer;
      }

      var params = this.formatter.getParams(tested);
      return wrap(params.join(this.paramSep));
    }
  }, {
    key: "parse",
    value: function parse(value) {
      var _value$toString, _this$formatter;

      var str = value === null || value === void 0 ? void 0 : (_value$toString = value.toString) === null || _value$toString === void 0 ? void 0 : _value$toString.call(value);
      if (typeof str !== 'string') return;

      if (this.formatter.jsonReplacer !== undefined && value === this.formatter.jsonReplacer) {
        return {
          value: this.formatter.hydrate()
        };
      }

      if (!(str.startsWith(this.blockStart) && str.endsWith(this.blockEnd))) {
        return;
      }

      var params = value.slice(this.blockStart.length).slice(0, -this.blockEnd.length).split(this.paramSep);
      return {
        value: (_this$formatter = this.formatter).hydrate.apply(_this$formatter, _toConsumableArray(params))
      };
    }
  }]);

  return Serializer;
}();

_defineProperty(Serializer, "SEP", SEP);

export var BJSONConstructor = /*#__PURE__*/function () {
  function BJSONConstructor() {
    var _this2 = this;

    var _options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, BJSONConstructor);

    _defineProperty(this, "serializers", []);

    _defineProperty(this, "stringify", function (value) {
      var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var handler = options.handler,
          quoteValues = options.quoteValues,
          quoteKeys = options.quoteKeys;
      var self = _this2;
      var str = stringify(value, _objectSpread(_objectSpread({}, options), {}, {
        quoteValues: quoteValues,
        quoteKeys: quoteKeys,
        defaultHandler: function defaultHandler(_ref) {
          var value = _ref.value,
              options = _ref.options;

          var serializer = _this2.serializers.find(function (el) {
            return el.formatter.match(value) !== undefined;
          });

          var handled = handler === null || handler === void 0 ? void 0 : handler(_objectSpread(_objectSpread({}, options), {}, {
            value: value,
            self: self,
            serializer: serializer
          }));
          if (handled !== undefined) return handled;
          if (!serializer) return undefined;
          return serializer.stringify(value);
        }
      }));
      return "".concat(str);
    });

    _defineProperty(this, "parse", function (input) {
      return JSON.parse(input, function (_key, value) {
        var _iterator = _createForOfIteratorHelper(_this2.serializers),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var serializer = _step.value;

            var _match = serializer.parse(value);

            if (_match !== undefined) return _match.value;
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        return value;
      });
    });

    this.serializers = [].concat(_toConsumableArray(BJSONConstructor.serializers), _toConsumableArray(_options.extraSerializers || []));
  }

  _createClass(BJSONConstructor, [{
    key: "getSerializer",
    value: function getSerializer(value) {
      var _value$split, _value$split$call;

      var name = value === null || value === void 0 ? void 0 : (_value$split = value.split) === null || _value$split === void 0 ? void 0 : (_value$split$call = _value$split.call(value, "".concat(Serializer.SEP))) === null || _value$split$call === void 0 ? void 0 : _value$split$call[0];
      if (!name) return;
      return this.serializers.find(function (s) {
        return s.name === name;
      });
    }
  }, {
    key: "tsName",
    value: function tsName(value) {
      var _this$getSerializer;

      return (_this$getSerializer = this.getSerializer(value)) === null || _this$getSerializer === void 0 ? void 0 : _this$getSerializer.formatter.tsName();
    }
  }]);

  return BJSONConstructor;
}();

_defineProperty(BJSONConstructor, "serializers", [new Serializer({
  name: 'Date',
  tsName: function tsName() {
    return 'Date';
  },
  hydrate: function hydrate(value) {
    return new Date(value);
  },
  getParams: function getParams(value) {
    return [value.toJSON()];
  },
  match: function match(value) {
    return value instanceof Date ? value : typeof value === 'string' ? dateSerialize(value) || undefined : undefined;
  }
}), new Serializer({
  name: 'RegExp',
  tsName: function tsName() {
    return 'RegExp';
  },
  hydrate: function hydrate(source, flags) {
    return new RegExp(source, flags);
  },
  getParams: function getParams(value) {
    return [value.source, value.flags];
  },
  match: function match(value) {
    return value instanceof RegExp ? value : undefined;
  }
}), new Serializer({
  name: 'NaN',
  tsName: function tsName() {
    return 'NaN';
  },
  hydrate: function hydrate() {
    return NaN;
  },
  getParams: function getParams() {
    return [];
  },
  match: function match(value) {
    return typeof value === 'number' && isNaN(value) ? value : undefined;
  }
}), new Serializer({
  name: 'Undefined',
  tsName: function tsName() {
    return 'undefined';
  },
  hydrate: function hydrate() {
    return undefined;
  },
  getParams: function getParams() {
    return [];
  },
  match: function match(value) {
    return value === undefined ? BJSON_UNDEFINED : undefined;
  },
  jsonReplacer: BJSON_UNDEFINED
}), new Serializer({
  name: 'Function',
  tsName: function tsName() {
    return 'Function';
  },
  hydrate: function hydrate() {
    return function __unknown__() {};
  },
  getParams: function getParams() {
    return [];
  },
  match: function match(value) {
    return typeof value === 'function' ? value : undefined;
  },
  jsonReplacer: BJSON_FUNCTION
})]);

// some parts from meteor ejson
export function stringify(value) {
  var _options$key;

  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var defaultHandler = options.defaultHandler,
      _options$quoteValues = options.quoteValues,
      quoteValues = _options$quoteValues === void 0 ? function (v) {
    return JSON.stringify(v);
  } : _options$quoteValues,
      _options$quoteKeys = options.quoteKeys,
      quoteKeys = _options$quoteKeys === void 0 ? JSON.stringify : _options$quoteKeys;
  var typeName = getTypeName(value);
  var info = {
    key: (_options$key = options === null || options === void 0 ? void 0 : options.key) !== null && _options$key !== void 0 ? _options$key : undefined
  };
  var handled = defaultHandler === null || defaultHandler === void 0 ? void 0 : defaultHandler({
    value: value,
    options: options
  });
  if (handled !== undefined) return quoteValues(handled, info);

  switch (typeName) {
    case 'String':
      return quoteValues(value, info);

    case 'NaN':
    case 'Infinity':
      return 'null';

    case 'Number':
      return quoteValues(value, info);

    case 'Boolean':
      return quoteValues(value, info);

    case 'Array':
      {
        var partial = [];
        var v; // Is the value an array?
        // The value is an array. Stringify every element. Use null as a
        // placeholder for non-JSON values.

        var length = value.length;

        for (var i = 0; i < length; i += 1) {
          partial[i] = stringify(value[i], _objectSpread(_objectSpread({}, options), {}, {
            key: i
          })) || 'null';
        } // Join all the elements together, separated with commas, and wrap
        // them in brackets.


        if (partial.length === 0) {
          v = '[]';
        } else {
          v = '[' + partial.join(',') + ']';
        }

        return v;
      }

    case 'Null':
      return 'null';

    case 'Undefined':
      return 'undefined';

    case 'Function':
      return 'function unknown(){}';

    default:
      {
        var _partial = [];

        var _v;

        var keys = Object.keys(value);
        keys.forEach(function (k) {
          _v = stringify(value[k], _objectSpread(_objectSpread({}, options), {}, {
            key: k
          }));

          if (_v) {
            _partial.push(quoteKeys(k) + ':' + _v);
          }
        }); // Join all the member texts together, separated with commas,
        // and wrap them in braces.

        if (_partial.length === 0) {
          _v = '{}';
        } else {
          _v = '{' + _partial.join(',') + '}';
        }

        return _v;
      }
  }
} // If the JSON object does not yet have a stringify method, give it one.

export var BJSON = new BJSONConstructor();
//# sourceMappingURL=BJSON.js.map