import { RuntimeError } from './RuntimeError';
import { areEqual } from './areEqual';
import { dynamicRequire } from './dynamicRequire';
var jestDiff = dynamicRequire('jest-diff', module);
export function assertSame(message, a, b) {
  if (!areEqual(a, b)) {
    if (jestDiff) {
      console.info(jestDiff.diff(a, b));
    }

    throw new RuntimeError(message, {
      expected: a,
      actual: b
    });
  }
}
//# sourceMappingURL=assertSame.js.map