import camelCase from 'lodash/camelCase';
import upperFirst from 'lodash/upperFirst';
import { randomItem } from './randomItem';
import { slugify as _slugify } from './slugify';
export function capitalize(input) {
  return upperFirst(input);
}
export function joinPathsCamelCase() {
  return camelCase(joinPathsSnakeCase.apply(void 0, arguments));
}
export function joinPathsSnakeCase() {
  for (var _len = arguments.length, parts = new Array(_len), _key = 0; _key < _len; _key++) {
    parts[_key] = arguments[_key];
  }

  return parts.filter(Boolean).join('_');
}
export var stringCase = {
  keep: function keep(s) {
    return s;
  },
  capitalized: function capitalized(s) {
    return capitalize(s);
  },
  lowercase: function lowercase(s) {
    return s.toLowerCase();
  },
  random: function random(s) {
    return stringCase[randomItem(Object.keys(stringCase))](s);
  },
  undefined: function undefined(s) {
    return stringCase.random(s);
  },
  slugify: function slugify(s) {
    return _slugify(s);
  }
};
//# sourceMappingURL=stringCase.js.map