"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  objectDiffPaths: true,
  getObjectDiffPaths: true
};
exports.getObjectDiffPaths = void 0;
exports.objectDiffPaths = objectDiffPaths;

var _deepObjectDiff = require("deep-object-diff");

Object.keys(_deepObjectDiff).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _deepObjectDiff[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _deepObjectDiff[key];
    }
  });
});

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function objectDiffPaths(originObject, newObject) {
  var changes = [];

  function walkObject(_originObject, _newObject, paths) {
    var path = paths[paths.length - 1] || '';

    function _currentPath(parent, key) {
      var isArray = Array.isArray(parent);
      return isArray ? path + "[".concat(key, "]") : !path ? key : "".concat(path, ".").concat(key);
    }

    for (var _i = 0, _Object$keys = Object.keys(_originObject); _i < _Object$keys.length; _i++) {
      var key = _Object$keys[_i];

      var currentPath = _currentPath(_originObject, key);

      if (!_newObject.hasOwnProperty(key)) {
        changes.push({
          kind: 'remove',
          newValue: undefined,
          oldValue: _originObject[key],
          path: currentPath,
          paths: [].concat(_toConsumableArray(paths), [currentPath])
        });
      }
    }

    for (var _i2 = 0, _Object$entries = Object.entries(_newObject); _i2 < _Object$entries.length; _i2++) {
      var _Object$entries$_i = _slicedToArray(_Object$entries[_i2], 2),
          _key = _Object$entries$_i[0],
          value = _Object$entries$_i[1];

      if (value === _originObject[_key]) continue;

      var _currentPath2 = _currentPath(_newObject, _key);

      if (!_originObject.hasOwnProperty(_key)) {
        changes.push({
          kind: 'add',
          newValue: _newObject[_key],
          oldValue: undefined,
          path: _currentPath2,
          paths: [].concat(_toConsumableArray(paths), [_currentPath2])
        });
      } else {
        if (value && _typeof(value) === 'object' && _originObject[_key] && _typeof(_originObject[_key]) === 'object') {
          walkObject(_originObject[_key], value, [].concat(_toConsumableArray(paths), [_currentPath2]));
        } else {
          changes.push({
            kind: 'update',
            newValue: _newObject[_key],
            oldValue: _originObject[_key],
            path: _currentPath2,
            paths: [].concat(_toConsumableArray(paths), [_currentPath2])
          });
        }
      }
    }
  }

  walkObject(originObject, newObject, []);
  return changes;
}

var getObjectDiffPaths = objectDiffPaths;
exports.getObjectDiffPaths = getObjectDiffPaths;
//# sourceMappingURL=objectDiff.js.map