"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.simpleObjectClone = simpleObjectClone;

var _fastCopy = _interopRequireDefault(require("fast-copy"));

var _RuntimeError = require("./RuntimeError");

var _sortObject = require("./sortObject");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function simpleObjectClone(input) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    sort: false
  };
  var sort = options.sort;

  if (!input || _typeof(input) !== 'object') {
    throw new _RuntimeError.RuntimeError('input is not a valid object', {
      input: input
    });
  }

  try {
    var res = (0, _fastCopy.default)(input);
    return sort ? (0, _sortObject.sortObject)(res) : res;
  } catch (e) {
    debugger;
    throw new _RuntimeError.RuntimeError('Failed to execute JSON.stringify() on input object', {
      input: input
    });
  }
}
//# sourceMappingURL=simpleObjectClone.js.map