"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.capitalize = capitalize;
exports.joinPathsCamelCase = joinPathsCamelCase;
exports.joinPathsSnakeCase = joinPathsSnakeCase;
exports.stringCase = void 0;

var _camelCase = _interopRequireDefault(require("lodash/camelCase"));

var _upperFirst = _interopRequireDefault(require("lodash/upperFirst"));

var _randomItem = require("./randomItem");

var _slugify2 = require("./slugify");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function capitalize(input) {
  return (0, _upperFirst.default)(input);
}

function joinPathsCamelCase() {
  return (0, _camelCase.default)(joinPathsSnakeCase.apply(void 0, arguments));
}

function joinPathsSnakeCase() {
  for (var _len = arguments.length, parts = new Array(_len), _key = 0; _key < _len; _key++) {
    parts[_key] = arguments[_key];
  }

  return parts.filter(Boolean).join('_');
}

var stringCase = {
  keep: function keep(s) {
    return s;
  },
  capitalized: function capitalized(s) {
    return capitalize(s);
  },
  lowercase: function lowercase(s) {
    return s.toLowerCase();
  },
  random: function random(s) {
    return stringCase[(0, _randomItem.randomItem)(Object.keys(stringCase))](s);
  },
  undefined: function undefined(s) {
    return stringCase.random(s);
  },
  slugify: function slugify(s) {
    return (0, _slugify2.slugify)(s);
  }
};
exports.stringCase = stringCase;
//# sourceMappingURL=stringCase.js.map