"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.base64ToText = base64ToText;
exports.textToBase64 = textToBase64;

var _expectedType = require("./expectedType");

var _isBrowser = require("./isBrowser");

function textToBase64(text) {
  (0, _expectedType.assertTypes)({
    text: text
  }, 'string');

  if ((0, _isBrowser.isBrowser)()) {
    return window.atob(text);
  }

  return Buffer.from(text).toString('base64');
}

function base64ToText(text) {
  (0, _expectedType.assertTypes)({
    text: text
  }, 'string');

  if ((0, _isBrowser.isBrowser)()) {
    return window.btoa(text);
  }

  return Buffer.from(text, 'base64').toString();
}
//# sourceMappingURL=textToBase64.js.map