"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypes = exports.expectedType = exports.InvalidExpectedTruthyError = exports.InvalidExpectedTypeError = void 0;
var getTypeName_1 = require("./getTypeName");
var InvalidExpectedTypeError = /** @class */ (function (_super) {
    __extends(InvalidExpectedTypeError, _super);
    function InvalidExpectedTypeError(fieldName, found, expected) {
        var _this = _super.call(this, "Expected ".concat(fieldName, " to be of type \"").concat(expected, "\", found ").concat(found, " instead.")) || this;
        _this.expected = expected;
        _this.fieldName = fieldName;
        _this.found = found;
        return _this;
    }
    return InvalidExpectedTypeError;
}(Error));
exports.InvalidExpectedTypeError = InvalidExpectedTypeError;
var InvalidExpectedTruthyError = /** @class */ (function (_super) {
    __extends(InvalidExpectedTruthyError, _super);
    function InvalidExpectedTruthyError(fieldName, value, foundType) {
        return _super.call(this, "Expected ".concat(fieldName, " to be have a truthy value, found \"").concat(value, "\" of type ").concat(foundType, ".")) || this;
    }
    return InvalidExpectedTruthyError;
}(Error));
exports.InvalidExpectedTruthyError = InvalidExpectedTruthyError;
function expectedType(input, expected, optional) {
    var e_1, _a;
    if (optional === void 0) { optional = false; }
    var entries = Object.entries(input);
    var expectedArr = (Array.isArray(expected) ? expected : [expected]).map(function (el) { return el.toLowerCase(); });
    if (optional === true) {
        expectedArr.push('undefined');
    }
    try {
        for (var entries_1 = __values(entries), entries_1_1 = entries_1.next(); !entries_1_1.done; entries_1_1 = entries_1.next()) {
            var _b = __read(entries_1_1.value, 2), key = _b[0], value = _b[1];
            var typename = (0, getTypeName_1.getTypeName)(value).toLowerCase();
            if (!expectedArr.includes(typename)) {
                throw new InvalidExpectedTypeError(key, typename, expectedArr.join(' or '));
            }
            if (optional === 'truthy' && !value) {
                throw new InvalidExpectedTruthyError(key, value, typename);
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (entries_1_1 && !entries_1_1.done && (_a = entries_1.return)) _a.call(entries_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return input;
}
exports.expectedType = expectedType;
exports.assertTypes = expectedType;
