"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getConstructorName = exports.getTypeName = void 0;
function getTypeName(input) {
    if (typeof input === 'number' && isNaN(input))
        return 'NaN';
    if (input === null)
        return 'Null';
    if (input === undefined)
        return 'Undefined';
    if (input === Infinity)
        return 'Infinity';
    return getConstructorName(input);
}
exports.getTypeName = getTypeName;
function getConstructorName(input) {
    var _a, _b, _c;
    var constructorName = (_c = (_b = (_a = input === null || input === void 0 ? void 0 : input.constructor) === null || _a === void 0 ? void 0 : _a.toString) === null || _b === void 0 ? void 0 : _b.call(_a).match(/function ([^(]*)/)) === null || _c === void 0 ? void 0 : _c[1];
    if (constructorName)
        return constructorName;
    if (input !== null && typeof input === 'object') {
        // objects without constructor (with Object.create(null))
        return 'Object';
    }
    return 'Unknown';
}
exports.getConstructorName = getConstructorName;
