"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.inspectObject = void 0;
var dynamicRequire_1 = require("./dynamicRequire");
var getTypeName_1 = require("./getTypeName");
function inspectObject(inputObject, options, appendDetailIndex) {
    if (options === void 0) { options = {}; }
    if (appendDetailIndex === void 0) { appendDetailIndex = false; }
    var _a = options.depth, depth = _a === void 0 ? 2 : _a, _b = options.tabSize, tabSize = _b === void 0 ? 6 : _b, named = options.named, _c = options.transformLine, transformLine = _c === void 0 ? appendDetailIndex
        ? function (text, index) { return "[".concat(index, "]: ").concat(text); }
        : function (t) { return t; } : _c;
    var inspect = function (obj, index) {
        var text = typeof obj === 'string' ? obj : _inspectObject(obj, { depth: depth });
        if (named === true) {
            text = "".concat((0, getTypeName_1.getTypeName)(obj), " ").concat(text);
        }
        else if (named) {
            text = "".concat(named, " ").concat(text);
        }
        return transformLine(text, index, obj);
    };
    var text = inspect(inputObject, 0);
    return appendTab(text, tabSize);
}
exports.inspectObject = inspectObject;
function appendTab(text, size) {
    if (size === void 0) { size = 4; }
    var tab = spaces(size);
    return text
        .split('\n')
        .map(function (t) { return "".concat(tab).concat(t); })
        .join('\n');
}
function spaces(size, space) {
    if (space === void 0) { space = ' '; }
    return __spreadArray([], __read(Array(size)), false).map(function () { return space; }).join('');
}
function _inspectObject(obj, config) {
    var _a;
    var nodeIns = (_a = (0, dynamicRequire_1.dynamicRequire)('util')) === null || _a === void 0 ? void 0 : _a.inspect;
    if (nodeIns) {
        return nodeIns(obj, config);
    }
    try {
        return JSON.stringify(obj, null, 2);
    }
    catch (e) {
        return 'FILED TO INSPECT';
    }
}
