"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLogLevelInfo = exports.LogLevels = void 0;
var env_1 = require("./env");
var typeUtils_1 = require("./typeUtils");
var useProcess_1 = require("./useProcess");
exports.LogLevels = (0, typeUtils_1.tuple)('error', 'info', 'crit', 'warning', 'debug');
var LEVEL = useProcess_1.Process.env.LOG_LEVEL || '';
if (!LEVEL && !(0, env_1.isProduction)()) {
    useProcess_1.Process.env.LOG_LEVEL = '2';
}
function getLogLevelInfo() {
    var env = useProcess_1.Process.env.LOG_LEVEL;
    var logInfo = env === '2';
    var logWarn = env === '1';
    if (env === '0') {
        return new Set();
    }
    var levels = ['error', 'crit'];
    if (logInfo) {
        levels.push('info', 'warning');
    }
    if (logWarn) {
        levels.push('warning');
    }
    if (!(0, env_1.isProduction)()) {
        levels.push('debug');
    }
    return new Set(levels);
}
exports.getLogLevelInfo = getLogLevelInfo;
