function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { inspectObject } from './inspectObject';
export class RuntimeError extends Error {
  /**
   * @deprecated use options via object RunTimeErrorOptions instead
   * @param message
   * @param details
   * @param skipStackLines
   * @param depth
   */
  constructor(message, details) {
    super(message);

    _defineProperty(this, "name", 'RuntimeError');

    _defineProperty(this, "details", void 0);

    _defineProperty(this, "detailsString", '');

    this.details = details;
    this.detailsString = message;

    for (var _len = arguments.length, _config = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++) {
      _config[_key - 2] = arguments[_key];
    }

    var {
      skipStackLines = 0,
      depth = 10,
      limitStackTrace = 100
    } = prepareArgs(_config);

    if (details) {
      var detailsString = inspectObject(details, {
        tabSize: 0,
        depth
      }) //
      .slice(0, limitStackTrace);
      this.detailsString += "\n".concat(detailsString);
      var stack = (this.stack || '').split('\n');
      var newStack = [message, ...stack.slice(0, 1).filter(e => e === '\n'), "Details: ".concat(detailsString), ...stack.slice(1 + skipStackLines)];
      this.stack = newStack.join('\n');
    }
  }

}

function prepareArgs(_config) {
  return typeof _config[0] === 'object' ? _config[0] : {
    skipStackLines: _config[0],
    depth: _config[1]
  };
}
//# sourceMappingURL=RuntimeError.js.map