function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { RuntimeError } from './RuntimeError';
export class StrictMap {
  constructor() {
    _defineProperty(this, "nativeMap", void 0);

    _defineProperty(this, "set", (key, value) => {
      return this.nativeMap.set(key, value);
    });

    _defineProperty(this, "has", key => {
      return this.nativeMap.has(key);
    });

    _defineProperty(this, "keys", () => {
      return this.nativeMap.keys();
    });

    _defineProperty(this, "entries", () => {
      return this.nativeMap.entries();
    });

    _defineProperty(this, "clear", () => {
      return this.nativeMap.clear();
    });

    _defineProperty(this, "delete", key => {
      return this.nativeMap.delete(key);
    });

    _defineProperty(this, "values", () => {
      return this.nativeMap.values();
    });

    this.nativeMap = new Map();
  }

  ensure(key) {
    this.get(key);
  }

  get(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!this.nativeMap.has(key)) {
      var {
        onNull
      } = options;

      if (onNull) {
        var newItem = onNull(key, this);

        if (newItem) {
          this.set(key, newItem);
          return newItem;
        }
      }

      throw new StrictMapError("There is no item with key \"".concat(key, "\""), {
        validKeys: [...this.nativeMap.keys()]
      });
    }

    var value = this.nativeMap.get(key);

    if (value === undefined || value === null) {
      throw new StrictMapError("Expected value to be not nullable, but received ".concat(value === null ? 'null' : 'undefined', "."), {
        validKeys: [...this.nativeMap.keys()]
      });
    }

    return value;
  }

  get size() {
    return this.nativeMap.size;
  }

}

class StrictMapError extends RuntimeError {
  constructor(message, details) {
    super(message, details);
    this.name = 'StrictMapError';
  }

}
//# sourceMappingURL=StrictMap.js.map