var _Process$env;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import fs from 'fs';
import nodePath from 'path';
import vm from 'vm';
import { Process } from '../useProcess';
import { isBuiltInModule } from './builtin-modules';
var ORIGINAL_REQUIRE = require;
var GET_PATHS = ORIGINAL_REQUIRE.resolve.paths;
var IS_PROD_ENV = ((_Process$env = Process.env) === null || _Process$env === void 0 ? void 0 : _Process$env.NODE_ENV) === 'production';
export class Contextify {
  constructor(options) {
    _defineProperty(this, "allBranches", new Set());

    _defineProperty(this, "persistentCache", void 0);

    _defineProperty(this, "filePathCache", Object.create(null));

    _defineProperty(this, "buildByExtension", void 0);

    _defineProperty(this, "allowSourcemaps", void 0);

    _defineProperty(this, "mock", void 0);

    _defineProperty(this, "contextModuleName", 'use-task-payload');

    _defineProperty(this, "getFileContents", filename => this._readFileFromDisk(filename));

    _defineProperty(this, "resolveModule", (path, currentDirname) => {
      return this._findNodeModulePath(path, currentDirname);
    });

    _defineProperty(this, "prepareRequire", config => {
      var {
        persistentCache,
        mock
      } = this;
      var {
        currentDirname,
        transitiveCache = Object.create(null),
        payload
      } = config;
      var self = this;

      var vmContext = (() => {
        var {
          vmContext,
          sandbox
        } = config;
        if (vmContext) return vmContext;
        if (!sandbox) return null;
        if (sandbox === true) return Contextify.prepareContext({});
        if (vm.isContext(sandbox)) return sandbox;
        return Contextify.prepareContext(sandbox);
      })();

      return function require(moduleName) {
        var filename = self.resolveModule(moduleName, currentDirname);
        var mocked = mock === null || mock === void 0 ? void 0 : mock({
          moduleName,
          filename,
          payload
        });

        if (mocked !== undefined) {
          transitiveCache[filename] = mocked;
          return mocked;
        }

        if (transitiveCache[filename]) {
          return transitiveCache[filename].exports;
        }

        if (moduleName === self.contextModuleName) {
          var _module = {
            exports: () => payload
          };
          transitiveCache[filename] = _module;
          return _module.exports;
        }

        if (isBuiltInModule(moduleName)) {
          return ORIGINAL_REQUIRE(moduleName);
        }

        if (!filename) {
          throw new Error("Cannot find module ".concat(moduleName));
        }

        var closure = persistentCache[filename];

        if (!closure) {
          var code = self._readFileWrapped(filename);

          var script = new vm.Script(code, {
            filename: filename,
            displayErrors: false
          });
          closure = vmContext ? script.runInContext(vmContext, {
            filename: filename,
            displayErrors: true
          }) : script.runInThisContext({
            filename: filename,
            displayErrors: true
          });

          if (!vmContext) {
            persistentCache[filename] = closure;
          }
        }

        var dirname = nodePath.dirname(filename);
        var module = {
          filename,
          exports: {},
          require: self.prepareRequire({
            currentDirname: dirname,
            transitiveCache,
            payload: payload,
            vmContext
          })
        };
        transitiveCache[filename] = module;
        var $TASK_MODULE_UTILS = {
          sourceMaps: () => {
            if (!self.allowSourcemaps) return;
            if (transitiveCache.installedSourcemaps) return;
            transitiveCache.installedSourcemaps = true;

            function retrieveFile(filename) {
              return self.persistentCache["".concat(filename, ".wrapped_module_contents")] || null;
            }

            require('source-map-support').install({
              retrieveFile,
              isTask: true
            });
          }
        };
        closure(module.exports, module.require, module, filename, dirname, $TASK_MODULE_UTILS);
        return module.exports;
      };
    });

    _defineProperty(this, "_readFileWrapped", filename => {
      var _this$buildByExtensio;

      var KEY = "".concat(filename, ".wrapped_module_contents");
      if (this.persistentCache[KEY]) return this.persistentCache[KEY];
      var extension = nodePath.extname(filename);
      var code;

      if ((_this$buildByExtensio = this.buildByExtension) !== null && _this$buildByExtensio !== void 0 && _this$buildByExtensio[extension]) {
        code = this.buildByExtension[extension](filename);
      } else {
        code = this.getFileContents(filename);
      }

      return this.persistentCache[KEY] = wrapModuleCode(code);
    });

    _defineProperty(this, "_findNodeModulePath", (path, currentDirname) => {
      if (path === this.contextModuleName) return this.contextModuleName;
      var cacheKey = "".concat(currentDirname, "_").concat(path);
      if (this.filePathCache[cacheKey]) return this.filePathCache[cacheKey];
      var filePath = ORIGINAL_REQUIRE.resolve(path, {
        paths: [currentDirname, ...(GET_PATHS(currentDirname) || [])]
      });
      return this.filePathCache[cacheKey] = filePath;
    });

    _defineProperty(this, "diskFilesCache", Object.create(null));

    _defineProperty(this, "_readFileFromDisk", filename => {
      var KEY = "".concat(filename, ".plain_disk_content");
      if (this.diskFilesCache[KEY]) return this.diskFilesCache[KEY];
      return this.diskFilesCache[KEY] = fs.readFileSync(filename, 'utf8');
    });

    this.persistentCache = options.persistentCache || Object.create(null);
    this.buildByExtension = options.buildByExtension;
    this.allowSourcemaps = typeof options.allowSourcemaps !== 'undefined' ? options.allowSourcemaps : !IS_PROD_ENV;
    this.mock = options.mock || null;

    if (options.contextModuleName) {
      this.contextModuleName = options.contextModuleName;
    }

    if (options.getFileContents) {
      this.getFileContents = options.getFileContents;
    }

    if (options.resolveModule) {
      var {
        resolveModule
      } = options;
      var self = this;

      this.resolveModule = (path, currentDirname) => {
        if (isBuiltInModule(path)) return path;
        if (path === self.contextModuleName) return self.contextModuleName;
        var result = resolveModule(path, currentDirname);

        if (!result) {
          throw new Error("Cannot find module ".concat(path, " - currentDirname: ").concat(currentDirname));
        }

        return result;
      };
    }
  }

  static prepareContext(sandbox) {
    return vm.createContext(_objectSpread({
      global: {
        isContextifySandbox: true
      },
      isTaskVMSandbox: true,
      process,
      console,
      version: parseInt(process.versions.node.split('.')[0]),
      setTimeout,
      setInterval,
      setImmediate,
      clearTimeout,
      clearInterval,
      clearImmediate,
      String,
      Number,
      Buffer,
      Boolean,
      Array,
      Date,
      Error,
      EvalError,
      RangeError,
      ReferenceError,
      SyntaxError,
      TypeError,
      URIError,
      RegExp,
      Function,
      Object,
      Proxy,
      Reflect,
      Map,
      WeakMap,
      Set,
      WeakSet,
      Promise,
      Symbol
    }, sandbox));
  }

}

function wrapModuleCode(code) {
  var strict = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var MODULE_PREFIX = '(function (exports, require, module, __filename, __dirname, $TASK_MODULE_UTILS) { ';
  var STRICT_MODULE_PREFIX = MODULE_PREFIX + '"use strict";$TASK_MODULE_UTILS.sourceMaps();\n';
  var MODULE_SUFFIX = '\n});';
  var prefix = strict ? STRICT_MODULE_PREFIX : MODULE_PREFIX;
  return prefix + code + MODULE_SUFFIX;
}
//# sourceMappingURL=Contextify.js.map