function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { getTypeName } from './getTypeName';
export class InvalidExpectedTypeError extends Error {
  constructor(fieldName, found, expected) {
    super("Expected ".concat(fieldName, " to be of type \"").concat(expected, "\", found ").concat(found, " instead."));

    _defineProperty(this, "fieldName", void 0);

    _defineProperty(this, "found", void 0);

    _defineProperty(this, "expected", void 0);

    this.expected = expected;
    this.fieldName = fieldName;
    this.found = found;
  }

}
export class InvalidExpectedTruthyError extends Error {
  constructor(fieldName, value, foundType) {
    super("Expected ".concat(fieldName, " to be have a truthy value, found \"").concat(value, "\" of type ").concat(foundType, "."));
  }

}
export function expectedType(input, expected) {
  var optional = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var entries = Object.entries(input);
  var expectedArr = (Array.isArray(expected) ? expected : [expected]).map(el => el.toLowerCase());

  if (optional === true) {
    expectedArr.push('undefined');
  }

  for (var [_key, value] of entries) {
    var typename = getTypeName(value).toLowerCase();

    if (!expectedArr.includes(typename)) {
      throw new InvalidExpectedTypeError(_key, typename, expectedArr.join(' or '));
    }

    if (optional === 'truthy' && !value) {
      throw new InvalidExpectedTruthyError(_key, value, typename);
    }
  }

  return input;
}
export var assertTypes = expectedType;
//# sourceMappingURL=expectedType.js.map