var filePathCache = Object.create(null);
export function findModulePath(moduleName, currentDirname) {
  var fs = require('fs');

  var ORIGINAL_REQUIRE = require;
  var cacheKey = "".concat(currentDirname, "_").concat(moduleName);
  if (filePathCache[cacheKey]) return filePathCache[cacheKey];
  var filePath = ORIGINAL_REQUIRE.resolve(moduleName, {
    paths: [currentDirname, ...(ORIGINAL_REQUIRE.resolve.paths(currentDirname) || [])]
  });

  if (!fs.existsSync(filePath)) {
    throw new Error("Cannot find module '".concat(moduleName, "'"));
  }

  return filePathCache[cacheKey] = filePath;
}
//# sourceMappingURL=findModulePath.js.map