import { dynamicRequire } from './dynamicRequire';
import { getTypeName } from './getTypeName';
export function inspectObject(inputObject) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var appendDetailIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var {
    depth = 2,
    tabSize = 6,
    named,
    transformLine = appendDetailIndex ? (text, index) => "[".concat(index, "]: ").concat(text) : t => t
  } = options;

  var inspect = (obj, index) => {
    var text = typeof obj === 'string' ? obj : _inspectObject(obj, {
      depth
    });

    if (named === true) {
      text = "".concat(getTypeName(obj), " ").concat(text);
    } else if (named) {
      text = "".concat(named, " ").concat(text);
    }

    return transformLine(text, index, obj);
  };

  var text = inspect(inputObject, 0);
  return appendTab(text, tabSize);
}

function appendTab(text) {
  var size = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 4;
  var tab = spaces(size);
  return text.split('\n').map(t => "".concat(tab).concat(t)).join('\n');
}

function spaces(size) {
  var space = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : ' ';
  return [...Array(size)].map(() => space).join('');
}

function _inspectObject(obj, config) {
  var _dynamicRequire;

  var nodeIns = (_dynamicRequire = dynamicRequire('util')) === null || _dynamicRequire === void 0 ? void 0 : _dynamicRequire.inspect;

  if (nodeIns) {
    return nodeIns(obj, config);
  }

  try {
    return JSON.stringify(obj, null, 2);
  } catch (e) {
    return 'FILED TO INSPECT';
  }
}
//# sourceMappingURL=inspectObject.js.map