import { isProduction } from './env';
import { tuple } from './typeUtils';
import { Process } from './useProcess';
export var LogLevels = tuple('error', 'info', 'crit', 'warning', 'debug');
var LEVEL = Process.env.LOG_LEVEL || '';

if (!LEVEL && !isProduction()) {
  Process.env.LOG_LEVEL = '2';
}

export function getLogLevelInfo() {
  var env = Process.env.LOG_LEVEL;
  var logInfo = env === '2';
  var logWarn = env === '1';

  if (env === '0') {
    return new Set();
  }

  var levels = ['error', 'crit'];

  if (logInfo) {
    levels.push('info', 'warning');
  }

  if (logWarn) {
    levels.push('warning');
  }

  if (!isProduction()) {
    levels.push('debug');
  }

  return new Set(levels);
}
//# sourceMappingURL=logLevels.js.map