import clone from 'fast-copy';
import { RuntimeError } from './RuntimeError';
import { sortObject } from './sortObject';
export function simpleObjectClone(input) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    sort: false
  };
  var {
    sort
  } = options;

  if (!input || typeof input !== 'object') {
    throw new RuntimeError('input is not a valid object', {
      input
    });
  }

  try {
    var res = clone(input);
    return sort ? sortObject(res) : res;
  } catch (e) {
    debugger;
    throw new RuntimeError('Failed to execute JSON.stringify() on input object', {
      input
    });
  }
}
//# sourceMappingURL=simpleObjectClone.js.map