import camelCase from 'lodash/camelCase';
import upperFirst from 'lodash/upperFirst';
import { randomItem } from './randomItem';
import { slugify as _slugify } from './slugify';
export function capitalize(input) {
  return upperFirst(input);
}
export function joinPathsCamelCase() {
  return camelCase(joinPathsSnakeCase(...arguments));
}
export function joinPathsSnakeCase() {
  for (var _len = arguments.length, parts = new Array(_len), _key = 0; _key < _len; _key++) {
    parts[_key] = arguments[_key];
  }

  return parts.filter(Boolean).join('_');
}
export var stringCase = {
  keep: s => s,
  capitalized: s => capitalize(s),
  lowercase: s => s.toLowerCase(),
  random: s => {
    return stringCase[randomItem(Object.keys(stringCase))](s);
  },
  undefined: s => stringCase.random(s),
  slugify: s => _slugify(s)
};
//# sourceMappingURL=stringCase.js.map