"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getObjectDiffPaths = exports.objectDiffPaths = void 0;
__exportStar(require("deep-object-diff"), exports);
function objectDiffPaths(originObject, newObject) {
    var changes = [];
    function walkObject(_originObject, _newObject, paths) {
        var e_1, _a, e_2, _b;
        var path = paths[paths.length - 1] || '';
        function _currentPath(parent, key) {
            var isArray = Array.isArray(parent);
            return isArray ? path + "[".concat(key, "]") : !path ? key : "".concat(path, ".").concat(key);
        }
        try {
            for (var _c = __values(Object.keys(_originObject)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var key = _d.value;
                var currentPath = _currentPath(_originObject, key);
                if (!_newObject.hasOwnProperty(key)) {
                    changes.push({
                        kind: 'remove',
                        newValue: undefined,
                        oldValue: _originObject[key],
                        path: currentPath,
                        paths: __spreadArray(__spreadArray([], __read(paths), false), [currentPath], false),
                    });
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        try {
            for (var _e = __values(Object.entries(_newObject)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var _g = __read(_f.value, 2), key = _g[0], value = _g[1];
                if (value === _originObject[key])
                    continue;
                var currentPath = _currentPath(_newObject, key);
                if (!_originObject.hasOwnProperty(key)) {
                    changes.push({
                        kind: 'add',
                        newValue: _newObject[key],
                        oldValue: undefined,
                        path: currentPath,
                        paths: __spreadArray(__spreadArray([], __read(paths), false), [currentPath], false),
                    });
                }
                else {
                    if (value &&
                        typeof value === 'object' &&
                        _originObject[key] &&
                        typeof _originObject[key] === 'object') {
                        walkObject(_originObject[key], value, __spreadArray(__spreadArray([], __read(paths), false), [currentPath], false));
                    }
                    else {
                        changes.push({
                            kind: 'update',
                            newValue: _newObject[key],
                            oldValue: _originObject[key],
                            path: currentPath,
                            paths: __spreadArray(__spreadArray([], __read(paths), false), [currentPath], false),
                        });
                    }
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return)) _b.call(_e);
            }
            finally { if (e_2) throw e_2.error; }
        }
    }
    walkObject(originObject, newObject, []);
    return changes;
}
exports.objectDiffPaths = objectDiffPaths;
exports.getObjectDiffPaths = objectDiffPaths;
