"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simpleObjectClone = void 0;
var fast_copy_1 = __importDefault(require("fast-copy"));
var RuntimeError_1 = require("./RuntimeError");
var sortObject_1 = require("./sortObject");
function simpleObjectClone(input, options) {
    if (options === void 0) { options = { sort: false }; }
    var sort = options.sort;
    if (!input || typeof input !== 'object') {
        throw new RuntimeError_1.RuntimeError('input is not a valid object', { input: input });
    }
    try {
        var res = (0, fast_copy_1.default)(input);
        return sort ? (0, sortObject_1.sortObject)(res) : res;
    }
    catch (e) {
        debugger;
        throw new RuntimeError_1.RuntimeError('Failed to execute JSON.stringify() on input object', {
            input: input,
        });
    }
}
exports.simpleObjectClone = simpleObjectClone;
