"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stringCase = exports.joinPathsSnakeCase = exports.joinPathsCamelCase = exports.capitalize = void 0;
var camelCase_1 = __importDefault(require("lodash/camelCase"));
var upperFirst_1 = __importDefault(require("lodash/upperFirst"));
var randomItem_1 = require("./randomItem");
var slugify_1 = require("./slugify");
function capitalize(input) {
    return (0, upperFirst_1.default)(input);
}
exports.capitalize = capitalize;
function joinPathsCamelCase() {
    var parts = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        parts[_i] = arguments[_i];
    }
    return (0, camelCase_1.default)(joinPathsSnakeCase.apply(void 0, __spreadArray([], __read(parts), false)));
}
exports.joinPathsCamelCase = joinPathsCamelCase;
function joinPathsSnakeCase() {
    var parts = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        parts[_i] = arguments[_i];
    }
    return parts.filter(Boolean).join('_');
}
exports.joinPathsSnakeCase = joinPathsSnakeCase;
exports.stringCase = {
    keep: function (s) { return s; },
    capitalized: function (s) { return capitalize(s); },
    lowercase: function (s) { return s.toLowerCase(); },
    random: function (s) {
        return exports.stringCase[(0, randomItem_1.randomItem)(Object.keys(exports.stringCase))](s);
    },
    undefined: function (s) { return exports.stringCase.random(s); },
    slugify: function (s) { return (0, slugify_1.slugify)(s); },
};
