"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.base64ToText = exports.textToBase64 = void 0;
var expectedType_1 = require("./expectedType");
var isBrowser_1 = require("./isBrowser");
function textToBase64(text) {
    (0, expectedType_1.assertTypes)({ text: text }, 'string');
    if ((0, isBrowser_1.isBrowser)()) {
        return window.atob(text);
    }
    return Buffer.from(text).toString('base64');
}
exports.textToBase64 = textToBase64;
function base64ToText(text) {
    (0, expectedType_1.assertTypes)({ text: text }, 'string');
    if ((0, isBrowser_1.isBrowser)()) {
        return window.btoa(text);
    }
    return Buffer.from(text, 'base64').toString();
}
exports.base64ToText = base64ToText;
